
Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #878

Simple playlists w/cuesheet as FIRST entry not handled correctly (patch included)

March 07, 2019 16:44 - Jim Turner

Status: Closed Start date: March 07, 2019

Priority: Minor Due date:  

Assignee:  % Done: 100%

Category: libaudcore Estimated time: 0.00 hour

Target version: 4.0   

Affects version: 3.10.1   

Description

Audacious will fail to play and may show incorrect title for a cuesheet if it is the FIRST entry in a "simple" playlist (ie. .m3u, .pls, etc.

that do not contain detailed info.), however as long as the first entry is NOT a cuesheet, all entries are handled properly.  Bug can

also be avoided by starting audacious with "-e" (so that the first item does not immediately start playing), leading me to believe that

it's a threading/scanning issue.

I was able to fix the issue by forcing a partial rescan of cuesheet entries (but without replacing the actual tuple data, as that replaces

the tuple info. (ie. title, artist) from the cuesheet with that of the tags contained in the actual song).  The patches included show the

changes I found needed to address this issue.  Please review, as you may be able to better address the issue.

Steps to reproduce:

1)  Create simple .m3u playlist with valid cuesheet reference (xxx.cue?#) as first entry followed by one or more entries (cuesheet or

otherwise).

2)  Run audacious ($>audacious myplaylist.m3u)

3)  First entry (the cuesheet entry) may/may not start playing and may/may not have correct title shown.

4)  Advance to next/another entry, which will play correctly.

5)  Try to play the first entry again, should fail ("Error reading metadata") and start playing next entry.

6)  [Playlist].[Refresh] playlist, and all then seems to be well.

History

#1 - March 13, 2019 16:21 - John Lindgren

I will look at this eventually, but it would save some time if you can upload the .m3u + .cue from your test case.

#2 - March 15, 2019 04:52 - Jim Turner

- File xbug.m3u added

- File DarkSideOfTheMoon_PinkFloyd.cue added

You will need to change the names and paths of the songs to some music files on your system.  I tested several cases, but here's one attached:

Regards,

Jim

#3 - March 16, 2019 19:31 - John Lindgren

- % Done changed from 0 to 100

- Target version set to 4.0

- Status changed from New to Closed
- Category set to libaudcore

- Affects version 3.10.1 added

- Affects version deleted (4.0)

Thanks for the test case.  The scanner.cc patch was somewhat along the right lines.  I simplified it a bit:

https://github.com/audacious-media-player/audacious/commit/1b6093af2ec01a8dddc3ffc59d4d739b88622ee6

Files

playlist-data.cc.diff 3.01 KB March 07, 2019 Jim Turner

scanner.cc.diff 1.4 KB March 07, 2019 Jim Turner

scanner.h.diff 361 Bytes March 07, 2019 Jim Turner

DarkSideOfTheMoon_PinkFloyd.cue 219 Bytes March 15, 2019 Jim Turner

xbug.m3u 141 Bytes March 15, 2019 Jim Turner
